window.$=function(obj){return typeof(obj)=="string"?document.getElementById(obj):obj}
var maxCatchNum = 3000;
function getConsoleHeight(){
	return $('zringDebugConsole').offsetHeight;
}

function clear(){
	parLogDiv = null;
	$('zringDebugConsole').innerHTML = "";
}

function toEnd(){
	//document.documentElement.scrollTop = (getConsoleHeight()- document.documentElement.offsetHeight);
	document.body.scrollTop = getConsoleHeight()-document.documentElement.clientHeight;
}
function getIsEnd(){
	if(getConsoleHeight()<document.documentElement.clientHeight){
		return true;
	}
	return (document.body.scrollTop == (getConsoleHeight()-document.documentElement.clientHeight));
}
function getAllString(isHTML){
	if(!isHTML){
		document.execCommand("selectAll",false,null);
		return getSelection();
	}else{
		return $('zringDebugConsole').innerHTML;
	}
}
function unSelect(){
	document.execCommand("Unselect",false,null);
}
var filterArr = [];
function addFilter(f){
	if("" == f){
		filterArr = [];
	}else{
		for(var i=filterArr.length-1;i>=0;i--){
			if(f == filterArr[i])return;
		}
		filterArr.push(f);
		showArr = null;
	}

	var arr = $('zringDebugConsole').childNodes;
	for(var i = arr.length-1;i>=0;i--){
		try{
			if("" == f){
				arr[i].style.display = "";
			}else{
				var debugType = arr[i].getAttribute("debugType");
				if(debugType == f){
					arr[i].style.display = "none";
				}
			}
		}catch(err){}
	}


}
var showArr = null;
function showlog(arr){
	if(null == arr || 0 == arr.length){
		showArr = null;
	}else{
		showArr = arr;
	}
	
	clear();
	var len = logDivs.length;
	for(var i=0;i<len;i++){
		try{
			if(null == showArr){
				//arr[i].style.display = "";
				$('zringDebugConsole').appendChild(logDivs[i]);
				debug_movieFun(logDivs[i],"alpha",100);
			}else{
				var debugType = logDivs[i].getAttribute("debugType");
				var find = false;
				for(var j = showArr.length-1;j>=0;j--){
					if(showArr[j] == debugType){
						$('zringDebugConsole').appendChild(logDivs[i]);
						debug_movieFun(logDivs[i],"alpha",100);

						find = true;
						break;
					}
				}
			}
		}catch(err){}
	}
	/*var arr = $('zringDebugConsole').childNodes;
	for(var i = arr.length-1;i>=0;i--){
		try{
			if(null == showArr){
				arr[i].style.display = "";
			}else{
				var debugType = arr[i].getAttribute("debugType");
				var find = false;
				for(var j = showArr.length-1;j>=0;j--){
					if(showArr[j] == debugType){
						arr[i].style.display = "";
						find = true;
						break;
					}
				}
				if(!find){
					arr[i].style.display = "none";
				}
			}
		}catch(err){}
	}*/

}
var parLogDiv;
var logDivs = [];
function appendLog(str,type,color){
	var b = getIsEnd();
	if(null == color){
		color = "";
	}else{
		color = " color:"+color;
	}
	//var display = "";
	var isShow = true;

	if(null != showArr && 0 != showArr.length){
		//display = " display:none;";
		isShow = false;
		for(var j = showArr.length-1;j>=0;j--){
			if(showArr[j] == type){
				//display = "";
				isShow = true;
				break;
			}
		}
	}else{
		for(var i=filterArr.length-1;i>=0;i--){
			if(filterArr[i] == type){
				//display = " display:none;";
				isShow = false;
				break;
			}
		}
	}

	if(null != parLogDiv && isShow){
		parLogDiv.setAttribute("al",100);
		parLogDiv.style.opacity = 100;
	}

	var logDiv = document.createElement("div");
	logDiv.style.cssText = "opacity:0;word-wrap: break-word; break-word: break-all;"+color;
	logDiv.innerHTML = str;
	logDiv.setAttribute("debugType",type);

	logDivs.push(logDiv);
	if(isShow){
		$('zringDebugConsole').appendChild(logDiv);

		debug_movieFun(logDiv,"alpha",100);

		parLogDiv = logDiv;
		/*var arr = $('zringDebugConsole').childNodes;
		if(maxCatchNum<arr.length){
			for(var i = maxCatchNum/2;i>=0;i--){
				try{
					$('zringDebugConsole').removeChild(arr[i]);
				}catch(err){}
			}
		}*/
		
		if(maxCatchNum<logDivs.length){
			for(var i = maxCatchNum/2;i>=0;i--){
				try{
					$('zringDebugConsole').removeChild(logDivs.pop());
				}catch(err){}
			}
		}

		if(b){
			toEnd();
		}

	}


	

}
var initObj;

function init(o){
	initObj = o;
	setMaxCatchNum(o.maxCatchNum);
	chat_createBasicCss();
	appendLog('<div id="copyRight" style="color:#8ADD30"><b><span style="font-size:24px;text-shadow: 1px 1px 5px #999999;color:#8ADD30">ZringDebug V'+o.version+'</span></b><br><br>&nbsp;&nbsp;&nbsp;&nbsp;copyright&copy; by zringhost 2006~2012<br><br></div>');
}


function setMaxCatchNum(num){
	if(null == num)return;
	maxCatchNum = num;
}
var chat_basicCssObj = null;

function chat_createBasicCss(){
	if(null != chat_basicCssObj)return;
	chat_basicCssObj = document.styleSheets[0];
	try{
		chat_addRule(chat_basicCssObj,'*','font-family: "����";font-size: 12px;color: '+initObj.fontColor+';');
	}catch(err){}
}

function chat_addRule(cssObj,selector,styles,n){
	if(cssObj.cssRules){
		if(typeof n == "undefined")n = cssObj.cssRules.length;
		cssObj.insertRule(selector + "{" + styles + "}", n);
	}else{
		if(typeof n == "undefined")n = cssObj.rules.length;
		cssObj.addRule(selector, styles, n);
	}
}


var global_Time = setInterval("timeFunction()",50);
var global_funArr = [];
var global_moveFunArr = [];
function timeFunction(){
	var currTime = new Date().getTime();
	for(var i=global_funArr.length-1;i>=0;i--){
		try{
			if(global_funArr[i].del){
				global_funArr.splice(i,1);
				continue;
			}
			if(global_funArr[i].time<=currTime-global_funArr[i].uTime){
				if("string" == typeof global_funArr[i].fStr){
					eval(global_funArr[i].fStr);
				}else{
					global_funArr[i].fStr();
				}
				if(0 == global_funArr[i].type){
					global_funArr.splice(i,1);
				}else{
					global_funArr[i].uTime = currTime;
				}
			}
		}catch(err){
			global_funArr.splice(i,1);
		}
	}
	for(var i=global_moveFunArr.length-1;i>=0;i--){
		try{
			var o =  global_moveFunArr[i];
			if("alpha" ==o.type){
				var al = o.obj.getAttribute("al");
				if(null == al)al = 0;
				else al = parseInt(al);
				if(1 >= Math.abs(o.to-al)){
					o.obj.setAttribute("al",o.to);
					al = o.to;
					if(null != o.fun){
						try{
							o.fun();
						}catch(err){}
					}
					global_moveFunArr.splice(i,1);
				}else{
					al += (o.to-al)*0.09;
				}
				o.obj.setAttribute("al",al);
				with(o.obj.style){
					filter = "alpha(opacity="+al+")";
					opacity = al/100;
					if(0 == al)display = "none";
					else display = "";
				}
			}else if("width" == o.type){
				zring_time_move_fun(o,i,o.obj.offsetWidth);
			}else if("height" == o.type){
				zring_time_move_fun(o,i,o.obj.offsetHeight);
			}else if("scrollTop" == o.type || "scrollLeft" == o.type){
				var num = o.obj[o.type];
				if(2 >= Math.abs(o.to-num)){
					o.obj[o.type] = o.to;
					if(null != o.fun){
						try{
							o.fun();
						}catch(err){}
					}
					global_moveFunArr.splice(i,1);
				}else{
					var src_num = o.obj[o.type];
					o.obj[o.type] = (num+(o.to-num)/2);
					if(o.obj[o.type] == src_num){
						if(null != o.fun){
							try{
								o.fun();
							}catch(err){}
						}
						global_moveFunArr.splice(i,1);
					}
				}
			}else{
				zring_time_move_fun(o,i,0);
			}/*else{
				global_moveFunArr.splice(i,1);
			}*/
		}catch(err){
			global_moveFunArr.splice(i,1);
		}
	}
		
	if("undefined" != typeof chat_isWinFocus && chat_isNewMsg){
			if(!chat_isWinFocus){
				if(null == chat_oldTitle){
					chat_oldTitle = document.title;
				}
				if(1000<=currTime-chat_upSetTitleTime){
					if("��" == document.title){
						document.title = chat_o.lan.titleAlert;
					}else{
						document.title = "��";
					}
					chat_upSetTitleTime = currTime;
				}
			}else{
				chat_isNewMsg = false;
				if(null != chat_oldTitle){
					document.title = chat_oldTitle;
					chat_oldTitle = null;
				}
			}
		}


}
function zring_time_move_fun(o,i,d_num){
	var num = o.obj.style[o.type];
	if("" == num || null == num){
		num = d_num;
	}else{
		var indexof = num.indexOf("px");
		if(0<=indexof){
			num = parseInt(num.substring(0,indexof));
		}
	}


	if(2 >= Math.abs(o.to-num)){
		o.obj.style[o.type] = o.to+"px";
		if(null != o.fun){
			try{
				o.fun();
			}catch(err){}
		}
		global_moveFunArr.splice(i,1);
	}else{
		o.obj.style[o.type] = (num+(o.to-num)/2)+"px";
	}
}
function z_setTimeout(funStr,time){
	var retO = {fStr:funStr,time:time,uTime:new Date().getTime(),type:0};
	global_funArr.push(retO);
	return retO;
}
/*function setTimeout(funStr,time){
	z_setTimeout(funStr,time);
}*/
function z_setInterval(funStr,time){
	var retO = {fStr:funStr,time:time,uTime:new Date().getTime(),type:1};
	global_funArr.push(retO);
	return retO;
}
function z_clearInterval(o){
	if(null != o){
		o.del = true;
	}
}

function debug_movieFun(obj,type,to,fun){
	for(var i=global_moveFunArr.length-1;i>=0;i--){
		if(global_moveFunArr[i].obj == obj && global_moveFunArr[i].type == type){
			global_moveFunArr[i].to = to;
			global_moveFunArr[i].fun = fun;
			return;
		}
	}
	global_moveFunArr.push({obj:obj,type:type,to:to,fun:fun});
}

//debug_movieFun($('copyRight'),"alpha",100);